<?php
defined('BASEPATH') OR exit('No direct script access allowed');

/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	https://codeigniter.com/userguide3/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are three reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router which controller/method to use if those
| provided in the URL cannot be matched to a valid route.
|
|	$route['translate_uri_dashes'] = FALSE;
|
| This is not exactly a route, but allows you to automatically route
| controller and method names that contain dashes. '-' isn't a valid
| class or method name character, so it requires translation.
| When you set this option to TRUE, it will replace ALL dashes in the
| controller and method URI segments.
|
| Examples:	my-controller/index	-> my_controller/index
|		my-controller/my-method	-> my_controller/my_method
*/
$route['default_controller'] = 'person';
$route['404_override'] = '';
$route['translate_uri_dashes'] = FALSE;
$route['login'] = "person/login";
$route['users'] = "user/users";

$route['no_access/(:any)'] = "no_access/index/$1";
$route['reports/summary_date_attendance/(:any)/(:any)'] = "reports/summary_date_attendance/$1/$2";
$route['reports/summary_employee_attendance/(:any)/(:any)'] = "reports/summary_employee_attendance/$1/$2";
$route['today-attendance'] = "attendance/today";

$route['upload-attendance'] = "attendance/upload_attendance";
$route['view-completed-records'] = "attendance/view_completed_rocords";
$route['view-records'] = "attendance/view_rocords";
$route['add-shift'] = "shift/post_shift/";
$route['add-shift/(:any)'] = "shift/post_shift/$1";

//$route['shift-transaction'] = "shift_transaction";
$route['shift-transaction'] = "shift_transaction/post_shift_transaction/";
$route['shift-transaction/(:any)/(:any)/(:any)'] = "shift_transaction/post_shift_transaction/$1/$2/$3";

//$route['leave-transaction'] = "leave_transaction";
$route['leave-transaction'] = "leave_transaction/post_leave_transaction/";
$route['leave-transaction/(:any)'] = "leave_transaction/post_leave_transaction/$1";

$route['main-transaction'] = "transaction/post_transaction/";
$route['main-transaction/(:any)'] = "transaction/post_transaction/$1";

$route['add-leave'] = "leave/post_leave/";
$route['add-leave/(:any)'] = "leave/post_leave/$1";


$route['add-employee'] = "employee/post_employee/";
$route['add-employee/(:any)'] = "employee/post_employee/$1";
$route['add-employee/(:any)/(:any)'] = "employee/post_employee/$1/$2";

$route['salary-increment'] = "payroll/increment";


